\documentclass[openany,a4paper,UTF8]{ctexart}
\usepackage{listings}
\newfontfamily\codefont{DejaVu Sans Mono}
\setmonofont{DejaVu Sans Mono}
\lstset{basicstyle=\small\codefont,frame=single,numbers=none}
\setCJKmainfont[Mapping = fullwidth-stop, % 中文空心句号映射为实心句点
  BoldFont=FZHei-B01,ItalicFont=FZKai-Z03,
  BoldItalicFont=FZFangSong-Z02]{FZNewShuSong-Z10}

\begin{document}
\thispagestyle{empty}
\noindent
{\bf 2024年网鼎杯，赛前模拟训练，逆向工程，reverse01}

\noindent
某次服务器巡检过程中，发现一个可疑的Java源码，
请根据提供的源码文件，分析找到隐藏在代码中的关键信息。

\bigskip\noindent
将题目所给的 zip 文件解压，得到 java 源码文件，编写以下 C\# 程序解答。
\begin{lstlisting}[numbers=left]
using System;
using System.IO;

static class A
{
    static void Main()
    {
        var a = new char[20];
        foreach (var s in File.ReadLines
            ("1/ReverseEngineeringChallenge.java"))
        {
            var t = s.Trim();
            if (!t.StartsWith("password")) continue;
            t = t.Substring(t.IndexOf('(') + 1);
            var n = int.Parse(t.Substring(0, t.IndexOf(')')));
            a[n] = t[t.IndexOf('\'')+1];
        }
        Console.WriteLine(new String(a));
    }
}
\end{lstlisting}

\noindent
编译并运行这个 C\# 程序得到答案。
\begin{lstlisting}
$ mcs a.cs && mono a.exe
flag{2024____W_D_B!}
\end{lstlisting}
\end{document}
